## R-0.64.2.tgz

=== src/gnuwin32/Makefile ===
include MkRules

HELP=YES

PACKAGES=base eda lqs modreg mva stepfun
RPREFIX=rw0642

ifdef DEBUG
 OPTFLAGS=-g -O2
 DLLFLAGS=
else
 OPTFLAGS=-O2 -Wall
 DLLFLAGS=-s 
endif

DIRS=  . ../nmath ../appl ../main
R-DLLFLAGS= $(STRIPFLAG) -mwindows
R-DLLLIBS=-L. $(FLIBS) -lwsock32 -lcomctl32
SOURCES=$(foreach i, $(DIRS), $(wildcard $i/*.c $i/*.f))
UFILES= ../unix/devPS.c ../unix/devPicTeX.c ../unix/sock.c ../unix/Rsock.c
LIBFILES=$(foreach i, $(PACKAGES), ../../library/$i)

OBJSO=$(foreach i, $(SOURCES) $(UFILES) $(EXTRAFILES), $(basename $i).o)
OBJS-NO=
OBJS=$(filter-out $(OBJS-NO),$(OBJSO))
PKGS=$(foreach i, $(PACKAGES), pkg-$i)
DIRSOBJ=$(foreach i, $(DIRS) ../unix , $i/*.o)
EXTRALIBS=rx.a ga.a gl.a xdr.a em.a

.PHONY:  clean veryclean  rlibs fixfiles front-ends

all: rbuild rdemo rpackage

CFLAGS=$(OPTFLAGS) -I../include
FFLAGS=$(OPTFLAGS)

../main/saveload-CFLAGS=-Ixdr
../main/character-CFLAGS=-Iregex
../main/platform-CFLAGS=-Iregex
../unix/sock-CFLAGS=-DWin32
../unix/Rsock-CFLAGS=-DWin32

rbuild: fixfiles makeMakedeps rlibs ../../bin/R.dll libR.a \
	../include/globalvar.h front-ends COPYRIGHTS

rpackage: $(PKGS)

rinstaller:
	$(MAKE) -C installer PREFIX=$(RPREFIX)

rdemo:  libR.a
	make -C ../../demos/dynload -f ../../src/gnuwin32/MkDyndemo

rlibs $(EXTRALIBS):
	$(MAKE) -C ./regex
	$(MAKE) -C ./graphapp
	$(MAKE) -C ./getline
	$(MAKE) -C ./xdr
	$(MAKE) -C ./math

COPYRIGHTS: ../../COPYRIGHTS COPYRIGHTS.win
	cat $^ > $@

fixfiles:
	$(MKDIR) -p ../../bin 
	$(MAKE) -C ./fixed
	$(CP) -pr unzip ../..
	$(RM) ../../unzip/*.h

R.dll: R.a $(EXTRALIBS)

../../bin/R.dll: fixfiles rlibs R.dll
	$(MKDIR) -p ../../bin
	$(CP) R.dll ../../bin/

front-ends: libR.a
	$(MAKE) -C front-ends

R.a: $(OBJS)
	@$(ECHO) -------- Building $@ --------
	$(AR) cr R.a $(DIRSOBJ)
	$(RANLIB) R.a


# R.dll exports all global symbols BUT import library (libR.a)
# only (all functions) + (global vars listed  in exported-vars))

libR.a:  R.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll --def R.exp --output-lib libR.a

# This fails on djtools make:
R.exp: R.exp1
	(diff R.exp R.exp1 > /dev/null) || $(CP) R.exp1 R.exp

R.exp1: R.a $(EXTRALIBS) exported-vars
	$(ECHO) EXPORTS > $@
	$(NM) R.a $(EXTRALIBS) > RDefs
	$(SED) -n "/^........ [T] _/s/^........ [T] _/ /p" RDefs >> $@
	$(CAT) exported-vars >> $@
	$(RM) RDefs

../main/gram.c: ;

../nmath/fround.o: ../nmath/fround.c
	$(CC) -I../include  -o $@ -c $^

# avoid building globalvar.h with errors
../include/globalvar.h: exported-vars
	$(AWK) -- '//{if ($$1 != "") print "#define " $$1 " (*__imp_" $$1 ")"}' \
	           exported-vars > ../include/globalvar.h

base-HELP=ziponly

pkg-%:  libR.a #../include/globalvar.h
	$(MAKE) DLLNM=$($*-DLLNM)  EXTRADOCS=$($*-EXTRADOCS) -C ../library/$* PKG=$* -f ../../gnuwin32/MakePkg
ifeq ($(strip $(HELP)),YES)
	$(MAKE) -C ./help $($*-HELP)help-$*
	$(MAKE) -C ./help contents-$*
endif

pkgcheck-%:
	@$(ECHO) -------- Testing package $* --------
	-@mkdir -p ../library/$*/check
	@$(MAKE) -C ../library/$*/check PKG=$* -f ../../../gnuwin32/check/PkgCheck

ziphelp-%:
	$(MAKE) -C ./help ziphelp-$*
	$(MAKE) -C ./help contents-$*

ziponly-%:
	$(MAKE) -C ./help ziponlyhelp-$*
	$(MAKE) -C ./help contents-$*

bootstrap-DLLNM=boott

clean: cleanwin
	$(RM) -f $(OBJS) $(WINOBJS) *.a ../*/*.d

distclean veryclean: clean
	$(RM) -rf R.exp ../../bin ../../library
	$(RM) -f ../library/*/src/*.o ../library/*/src/*.a
	$(RM) -f ../library/*/src/*.def ../library/*/src/*.dll
	$(RM) -rf ../library/*/check
	$(RM) -f ../../doc/html/search/index.txt \
	../../doc/html/function.html ../../doc/html/packages.html \
	../../demos/dynload/zero.def ../../demos/dynload/zero.dll \
	../../demos/dynload/zero.o \
	../../etc/R* ../../etc/rgb.txt \
	../include/FFDecl.h ../include/FFTab.h ../include/Platform.h \
	../include/globalvar.h ../../tests/*.Rout ../../tests/*.Rout.fail

cleanwin:
	$(RM) *.o *.exe *.dll *.a *~ \#*\# *.zip R.def R.exp1 \
	.RData .Rhistory Makedeps *.d
	$(MAKE) -C graphapp clean
	$(MAKE) -C fixed clean
	$(MAKE) -C regex clean
	$(MAKE) -C getline clean
	$(MAKE) -C help clean
	$(MAKE) -C front-ends clean
	$(MAKE) -C xdr clean
	$(MAKE) -C math clean
	-$(MAKE) -C installer clean


bindist:
	$(RM) -rf $(RPREFIX) library
	$(MKDIR) $(RPREFIX)
	$(CP) -pr ../../bin ../../afm ../../demos  ../../unzip $(RPREFIX)
	$(MKDIR) $(RPREFIX)/library
	$(CP) -pr $(LIBFILES) $(RPREFIX)/library
	$(RM) $(RPREFIX)/demos/dynload/*.o
	$(MKDIR) $(RPREFIX)/etc
	$(CP) -p ../../etc/Rprofile $(RPREFIX)/etc/Rprofile
	$(CP) -p ../../etc/Rconsole $(RPREFIX)/etc/Rconsole
	$(CP) -p ../../etc/Rdevga $(RPREFIX)/etc/Rdevga
	$(CP) -p ../../etc/rgb.txt $(RPREFIX)/etc/rgb.txt
	$(MKDIR) $(RPREFIX)/doc
	$(CP) -pr ../../doc/html $(RPREFIX)/doc
	$(CP) -p ../../COPYING COPYRIGHTS ../../FAQ ../../NEWS \
		../../Y2K $(RPREFIX)
	$(CP) -p readme $(RPREFIX)/README
	$(CP) -p rw-faq $(RPREFIX)/rw-faq
	$(CP) -p Announce $(RPREFIX)/Announce
	$(CP) -p CHANGES $(RPREFIX)/CHANGES
	zip -l docs.zip $(RPREFIX)/*
	unzip -o docs.zip
	$(RM) docs.zip
	$(RM) -rf $(RPREFIX)b.zip $(RPREFIX)h.zip $(RPREFIX)w.zip $(RPREFIX)l.zip
	$(RM) anindex.zip
	zip -mrX anindex.zip $(RPREFIX)/library/*/help/AnIndex $(RPREFIX)/library/*/help/00Titles
	zip -mrX $(RPREFIX)h.zip $(RPREFIX)/library/*/help \
		$(RPREFIX)/library/*/R-ex
	unzip anindex.zip
	$(RM) anindex.zip
	zip -rmX $(RPREFIX)w.zip $(RPREFIX)/doc/html $(RPREFIX)/library/*/html
	zip -rmX $(RPREFIX)l.zip $(RPREFIX)/library/*/latex
	zip -rX $(RPREFIX)b.zip $(RPREFIX)
	$(RM) -rf $(RPREFIX)



srcdist:
	$(RM) -r ../src src
	$(MKDIR) ../src
	$(MKDIR)  ../src/gnuwin32
	$(CP)  -pr ./* ../src/gnuwin32
	$(RM) -r ../src/gnuwin32/old ../src/gnuwin32/*.zip
	$(RM) -r ../src/gnuwin32/installer/unzip
	$(MAKE) -C ../src/gnuwin32 cleanwin
	mv ../src .
	$(RM) $(RPREFIX)s.zip
	zip -rX  $(RPREFIX)s.zip src
	$(RM) -r src


#taken from ../include/makefile.in
SRC_HEADERS = S.h S_compat.h f2c.h Arith.h Complex.h Error.h Errormsg.h \
	 Fortran.h Applic.h Blas.h Linpack.h Mathlib.h Memory.h PrtUtil.h \
	 Random.h Rinternals.h Utils.h Platform.h FFDecl.h FFTab.h globalvar.h

packagedist:
	$(RM) -r $(RPREFIX)sp.zip $(RPREFIX)
	$(MKDIR) $(RPREFIX) $(RPREFIX)/src $(RPREFIX)/src/include 
	$(MKDIR) $(RPREFIX)/src/library $(RPREFIX)/src/gnuwin32 
	$(MKDIR) $(RPREFIX)/src/gnuwin32/help
	$(CP) -p ../../COPYING exported-vars R.exp MkRules MakePkg MakeDll $(RPREFIX)/src/gnuwin32
	$(CP) -p Makefile.packages $(RPREFIX)/src/gnuwin32/Makefile
	$(CP) -p help/* $(RPREFIX)/src/gnuwin32/help
	$(MAKE) -C $(RPREFIX)/src/gnuwin32/help clean
	$(CP) -p $(foreach i,$(SRC_HEADERS),../include/$i) $(RPREFIX)/src/include
	$(CP) readme.packages $(RPREFIX)
	zip -r $(RPREFIX)sp.zip $(RPREFIX)
	$(RM) -r $(RPREFIX)


distribution: bindist packagedist

# tests
check: all test
test: stricttests pkgtests

stricttests:
	-@$(MAKE) -C ../../tests -f ../src/gnuwin32/check/Maketests clean
	-@$(MAKE) -C ../../tests -f ../src/gnuwin32/check/Maketests

PKGS-CHK=$(foreach i, $(PACKAGES), pkgcheck-$i)
pkgtests: $(PKGS-CHK)

pkgcheck-base:
	@$(ECHO) -------- Testing package base --------
	@(cd ../../library/base/R-ex; unzip -oq Rex)
	-@mkdir -p ../library/base/check
	-@$(MAKE) -C ../library/base/check PKG=base -f ../../../gnuwin32/check/PkgCheck
	@(cd ../../library/base/R-ex; rm -f *.R)

# Dependencies
CSOURCES=$(foreach i, $(DIRS), $(wildcard $i/*.c))
DEPS=$(foreach i, $(CSOURCES) $(UFILES), $(basename $i).d)

.c.d:
	@echo "making $@ from $<"
	@$(CC)  -M $(CFLAGS) $($*-CFLAGS) $< -o $@

makeMakedeps: $(DEPS)
	@$(RM) Makedeps
	@cat $(DEPS) >> Makedeps

-include Makedeps

=== src/gnuwin32/installer/Makefile ===
# Makefile for R for Windows Installer

PREFIX=rw0642
include ../MkRules
UNZIPDIR=unzip

.PHONY: GA UZ

all: R.ico GA UZ rwinst.exe

# O1 for small rather than fast
CFLAGS=-I../graphapp -I../../include -I$(UNZIPDIR)/windll -Wall -O1 \
        -DRVER=\"$(PREFIX)\"

GA:
	$(MAKE) -C ../graphapp

UZ:
	$(MAKE) -C $(UNZIPDIR) -f ../Makefile.unzip

R.ico: ../front-ends/R.ico
	$(CP) -p ../front-ends/R.ico .

rwico.o: rwico.rc

rwinst.o: ../../include/Platform.h ../graphapp/ga.h ../graphapp/graphapp.h

rwinst.exe: rwinst.o rwico.o dounzip.o ../ga.a $(UNZIPDIR)/unzip32.a
	$(CC) -s -mwindows -o $@ $^ -lcomctl32

clean:
	$(RM) R.ico *.o *~ \#*\# rwinst.exe
	-$(MAKE) -C $(UNZIPDIR) -f ../Makefile.unzip clean

=== debian/changelog ===
r-base (0.64.2-1) unstable; urgency=low

  * New upstream release
  * Changed dependency from perl to perl5 as per new policy.	
	
 -- Douglas Bates <bates@stat.wisc.edu>  Thu,  1 Jul 1999 09:05:03 -0500

r-base (0.64.1-1) unstable; urgency=low

  * New upstream release
  * Change definition of RHOME in /usr/lib/R/bin/R shell script (Bug#37339)
  * Add links so /usr/lib/R/doc/manual .tex files can be LaTeX'd (Hubert Palme)
  * Re-introduced md5sum's but with files that can change removed (Bug#35744)
  * Removed arbitrary --vsize and --nsize flags in R script.

 -- Douglas Bates <bates@stat.wisc.edu>  Wed, 12 May 1999 11:48:22 -0500
    

r-base (0.64.0-2) unstable; urgency=low

  * removed md5sums from control information (Bug#35744)

 -- Douglas Bates <bates@stat.wisc.edu>  Thu,  8 Apr 1999 08:48:32 -0500

r-base (0.64.0-1) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Thu,  1 Apr 1999 11:03:17 -0600

r-base (0.63.3-2) unstable; urgency=low

  * Recompile for glibc2.1 to fix __setfpucw bug (Bug#34598)

 -- Douglas Bates <bates@stat.wisc.edu>  Wed, 17 Mar 1999 13:42:41 -0600

r-base (0.63.3-1) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Thu,  4 Mar 1999 09:20:41 -0600

r-base (0.63.2-1) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Fri, 15 Jan 1999 09:25:20 -0600

r-base (0.63.1-1) unstable; urgency=low

  * New upstream release
  * Linked html directory to /usr/doc/r-base/doc/html (Dirk Eddelbuettel)

 -- Douglas Bates <bates@stat.wisc.edu>  Fri,  4 Dec 1998 14:22:19 -0600

r-base (0.63.0-2) unstable; urgency=low

  * recompiled against libc6-dev_2.0.7u-6 for __register_frame_info fix

 -- Douglas Bates <bates@stat.wisc.edu>  Sun, 29 Nov 1998 15:39:48 -0600

r-base (0.63.0-1) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Wed, 18 Nov 1998 13:33:58 -0600

r-base (0.62.4-1) frozen unstable; urgency=low, closes=26444

  * New upstream release
  * Fixed link to html directory in /usr/doc (Bug#26444)
  * Check for /usr/bin/paperconf in postinst and set default R_PAPERSIZE (Bug#26447)
  * Remove src/lib directory in debian/rules clean (Bug#28545)

 -- Douglas Bates <bates@stat.wisc.edu>  Mon,  2 Nov 1998 09:29:20 -0600

r-base (0.62.3-0) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Wed, 19 Aug 1998 10:38:08 -0500

r-base (0.62.2-2) unstable; urgency=low

  * Cleaned up the build process by removing redundancies in config.site
    and debian/rules.
  * Changed C compiler to gcc instead of egcs.

 -- Douglas Bates <bates@stat.wisc.edu>  Fri, 14 Aug 1998 13:52:34 -0500

r-base (0.62.2-1) unstable; urgency=low

  * Re-configured to include the readline library

 -- Douglas Bates <bates@stat.wisc.edu>  Fri, 14 Aug 1998 11:38:35 -0500

r-base (0.62.2-0) unstable; urgency=low

  * New upstream version

 -- Douglas Bates <bates@stat.wisc.edu>  Tue, 14 Jul 1998 13:36:15 -0500

r-base (0.62.1-2) unstable; urgency=low

  * Corrected definition of RHOME in /usr/bin/R (bug#23621)
  
  * Changed default heap size to 8 Mb. and number of cons cells to 400000

 -- Douglas Bates <bates@stat.wisc.edu>  Wed, 17 Jun 1998 11:48:28 -0500

r-base (0.62.1-1) unstable; urgency=low

  * new upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Tue, 16 Jun 1998 10:03:49 -0500

r-base (0.61.3-0) unstable; urgency=low

  * new upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Mon,  4 May 1998 12:05:53 -0500

r-base (0.61.2-2) frozen unstable; urgency=low

  * recompiled against xlib6g (bug #21027)

 -- Douglas Bates <bates@stat.wisc.edu>  Mon, 13 Apr 1998 14:05:33 -0500

r-base (0.61.2-1) frozen unstable; urgency=low

  * Added symbolic link for /usr/lib/R/library in /usr/doc/r-base/ (bug#20190)

 -- Douglas Bates <bates@stat.wisc.edu>  Thu, 26 Mar 1998 14:01:57 -0600

r-base (0.61.2-0) unstable; urgency=low

  * New upstream release.

 -- Douglas Bates <bates@stat.wisc.edu>  Mon,  9 Mar 1998 15:22:31 -0600

r-base (0.61.1-5) unstable; urgency=low

  * Removed call to dh_du in build rules.

 -- Douglas Bates <bates@stat.wisc.edu>  Fri,  6 Mar 1998 13:47:54 -0600

r-base (0.61.1-4) unstable; urgency=low

  * Removed unnecessary call to dh_makeshlibs in build rules

 -- Douglas Bates <bates@stat.wisc.edu>  Mon, 16 Feb 1998 13:49:44 -0600

r-base (0.61.1-3) unstable; urgency=low

  * Re-compiled to add readline support.

 -- Douglas Bates <bates@stat.wisc.edu>  Sat, 17 Jan 1998 17:06:52 -0600

r-base (0.61.1-2) unstable; urgency=low

  * Ensured that libraries for the modules are dynamically linked.

 -- Douglas Bates <bates@stat.wisc.edu>  Wed, 14 Jan 1998 08:31:53 -0600

r-base (0.61.1-1) unstable; urgency=low

  * New upstream release

 -- Douglas Bates <bates@stat.wisc.edu>  Mon, 12 Jan 1998 09:30:04 -0600

r-base (0.61.0-3) unstable; urgency=low

  * Went through all the warnings reported by -Wall to produce a patch
    file for the developers.
  * Applied Thomas Lumley's patch for problem with c() applied to ordered.
  * Changed debian/rules to delete the .in files for autoconf from the
    package
  
  * Changed priority to "optional"
  * Modified to use pristine original sources.

 -- Douglas Bates <bates@stat.wisc.edu>  Sun,  4 Jan 1998 14:54:04 -0600

r-base (0.61.0-2) unstable; urgency=low

  * Modified the format of the orig.tar.gz file

 -- Douglas Bates <bates@stat.wisc.edu>  Tue, 23 Dec 1997 12:02:09 -0600

r-base (0.61.0-1) unstable; urgency=low

  * Initial release

 -- Douglas Bates <bates@stat.wisc.edu>  Tue, 23 Dec 1997 10:01:21 -0600

Local variables:
mode: debian-changelog
add-log-mailing-address: "bates@stat.wisc.edu"
End:

=== debian/control ===
Source: r-base
Section: math
Priority: optional
Maintainer: Douglas Bates <bates@stat.wisc.edu>
Standards-Version: 2.4.0.0

Package: r-base
Architecture: any
Depends: perl5, ${shlibs:Depends}
Suggests: g77, libpaperg
Description: `GNU S' - A language and environment for statistical computing.
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for the Debian GNU/Linux r-base package
# Copyright 1997, 1998 by Douglas M. Bates <bates@stat.wisc.edu>

package=r-base

build:
	dh_testdir
	CFLAGS="-Wall -O2" FFLAGS="-Wall -O2"\
	 SHLIBLDFLAGS="-shared -lc" ./configure --prefix=/usr --with-g77
	make 
	make help
	make html

	touch build

clean:
	dh_testdir
	-rm -f build
	-make distclean
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp debian/files* core debian/substvars
	-rm -f doc/html/function.html doc/html/packages.html

# Build architecture-independent files here.
binary-indep: build
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	make install prefix=`pwd`/debian/tmp/usr
	sed -e '/^RHOME=.*/s::RHOME=/usr/lib/R:' \
	  < bin/R > debian/tmp/usr/bin/R
	sed -e '/^RHOME=.*/s::RHOME=/usr/lib/R:' \
	  < bin/R > debian/tmp/usr/lib/R/bin/R
	dh_installdocs
	(cd debian/tmp/usr/doc/r-base/doc && ln -s ../../../lib/R/doc/html .)
	(cd debian/tmp/usr/doc/r-base && ln -s ../../lib/R/library .)
	dh_installmenu
	dh_installmanpages re_format.7 regex.3
	dh_installchangelogs NEWS
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_makeshlibs
	dh_md5sums -X'usr/bin/R'  -XLibIndex -Xindex.txt -Xfunction.html -Xpackages.html
	dh_builddeb

# Below here is fairly generic really

binary:		binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean checkroot
